/* interp.h
 *
 * copyright(c) Prabhas Chongstitvatana
 *					18 Aug 98
*/

#include <stdio.h>
/*
#define   DEBUG
*/
#define   TRUE	 	1
#define	  FALSE		0

#define	  maxprocess	5        /* max no. of process */
#define	  stacksize	5000     /* size of stack for each p */
#define   timelimit     5

#define   VALIDOP       43
#define   FUDGE         16        /* scratch area + 3  to chk stkovf */
#define	  DSSIZE	2000
#define   MAXCS		5000
#define	  MAXMEM	maxprocess * stacksize + DSSIZE

#define   maxmail       maxprocess
#define   maxtimer	maxprocess

typedef  int (*fnptr)();
typedef  unsigned char  uchar;

#define	   nil          0

#define    INIT         0         /* state of a process */
#define    READY        1
#define    RUNNING      2
#define    WAIT	      	3
#define    SEND     	4
#define    RECEIVE  	5
#define    TMWAIT      	6
#define    TMSEND     	7
#define    TMRECEIVE  	8
#define	   DELAY        9
#define    TERMINATED   10

typedef  int pdesc;	/* pointer to process descriptor */
typedef  int mailp;	/* pointer to mail */
typedef  char pstate;

typedef struct {
  pdesc pid;
  pdesc prev,next;
  pstate state;
  int ip,fp,sp,maxsp;
  mailp await,mbox;
} pdata;

typedef int sem;

typedef struct {
  pdesc id;
  int message;
  mailp next;
} mdata;

typedef int tmp;

#define   TOS           M[sp]
#define   NEXT          M[sp-1]
#define   pop2		sp -= 2

extern int M[MAXMEM];           /* data and stack segment memory */
extern pdata pcb[maxprocess];   /* process control block */
extern pdesc activep;		/* current active process */
extern int ip,fp,sp,maxsp;	/* current state of computation */
extern long vclock;
extern int pclock;