/* compiler.h
	P.Chongstitvatana
	19 Aug 97
*/

#include <stdio.h>
#include <string.h>
/*
#define DEBUG
*/
#define	TABLESIZE	127
#define LOCALSIZE       100
#define NAMELEN		32
#define MAXCS		5000

#define	tkIF		0
#define	tkELSE          1
#define	tkWHILE         2
#define	tkPRINT         3
#define	tkRETURN        4
#define	tkSEND          5
#define	tkRECEIVE       6
#define	tkWAIT          7
#define	tkSIGNAL        8
#define	tkREGION        9
#define	tkPROCESS       10
#define	tkGLOBAL        11
#define	tkSEMAPHORE     12
#define	tkMAIN          13
#define	tkIDENTIFIER    14
#define	tkNUMBER        15
#define	tkSTRING        16
#define	tkANDAND        17
#define	tkOROR          18
#define	tkEQEQ          19
#define	tkLT            20
#define	tkLE            21
#define	tkGT            22
#define	tkGE            23
#define	tkNE            24
#define tkAND		25
#define tkNOT           26
#define tkEQ            27
#define	tkSTAR          28
#define	tkSLASH         29
#define	tkPLUS          30
#define	tkMINUS         31
#define	tkCOMMA         32
#define	tkSEMICOLON     33
#define	tkLPAREN        34
#define	tkRPAREN        35
#define	tkLBRACKET      36
#define	tkRBRACKET      37
#define	tkLBRACE        38
#define	tkRBRACE        39
#define	tkFUNCTION	40
#define	tkAFTER		41
#define	tkDELAY		42
#define tkGETTIME	43
#define	tkEOF           44
#define tkNIL		45
#define	tkERROR         46

#define tySEMAPHORE     2
#define tyVECTOR        3
#define tySCALAR        4
#define tyPROCESS       5
#define tyFUNCTION      6
#define tyLOCAL		7

#define NL_CHAR		10
#define EOF_CHAR	255

#define  icLit		0
#define  icLval         1
#define  icLvalg        2
#define  icRval         3
#define  icRvalg        4
#define  icFetch        5
#define  icSet          6
#define  icIndex        7
#define  icJmp          8
#define  icJz           9
#define  icCall         10
#define  icFunc         11
#define  icProc         12
#define  icRet0         13
#define  icRet1         14
#define  icStop         15
#define  icAdd          16
#define  icSub          17
#define  icMul          18
#define  icDiv          19
#define  icMinus        20
#define  icNot          21
#define  icAnd          22
#define  icOr           23
#define  icLt           24
#define  icLe           25
#define  icEq           26
#define  icNe           27
#define  icGe           28
#define  icGt           29
#define  icPrint        30
#define  icPrintch      31
#define  icSend         32
#define  icReceive      33
#define  icWait         34
#define  icSignal       35
#define  icNop          36
#define  icTmSend	37
#define	 icTmReceive	38
#define	 icTmWait	39
#define	 icDelay	40
#define	 icGettime	41

typedef unsigned char uchar;

typedef struct {
  char name[NAMELEN];
  int  type;
  int  ref;
  int  arg;
  int  pid;
} sym_entry;

extern  int tok;		/* current token type, string */
extern  char tokstring[];
extern  int line;		/* current position */
extern  uchar CH;

